using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace VCATest
{
  public partial class Form1 : Form
  {
    //define const
    public const int SC_GIO_ON = 0x00000001;
    public const int SC_MOTION_ON = 0x00000002;

    public const int MB_BIT_LEFT = 0x0001;
    public const int MB_BIT_RIGHT = 0x0002;
    public const int MB_BIT_CENTER = 0x0010;

    public const int KB_BIT_CTRL = 0x0001;
    public const int KB_BIT_CTRL_RIGHT = 0x0002;
    public const int KB_BIT_SHIFT = 0x0004;
    public const int KB_BIT_SHIFT_RIGHT = 0x0008;
    public const int KB_BIT_ALT = 0x00010;
    public const int KB_BIT_ALT_RIGHT = 0x00020;
    public const int ER_API_MSG_OK = 200;
    public const int ER_API_MSG_NG = 205;
    public const int ER_API_MSG_NS = 210;
    public const int ER_API_MSG_UW = 215;
    public const int ER_API_MSG_UA = 220;
    public const int ER_HTTP_API_MSG_ERR = 300;

    private int motionCount = 0;
    private int alarmCount = 0;

    public Form1()
    {
      InitializeComponent();
    }

    private void axViewerCtrlActiveX1_OnDoubleClick(object sender, AxVIEWERCTRLAXLib._IViewerCtrlActiveXEvents_OnDoubleClickEvent e)
    {
      radioDoubleClick.Checked = true;
      displayMouseInfo(e.x, e.y, e.button, e.ctrlKey);
    }

    private void axViewerCtrlActiveX1_OnMouseDown(object sender, AxVIEWERCTRLAXLib._IViewerCtrlActiveXEvents_OnMouseDownEvent e)
    {
      radioMouseDown.Checked = true;
      displayMouseInfo(e.x, e.y, e.button, e.ctrlKey);
    }

    private void axViewerCtrlActiveX1_OnMouseEnter(object sender, AxVIEWERCTRLAXLib._IViewerCtrlActiveXEvents_OnMouseEnterEvent e)
    {
      radioMouseEnter.Checked = true;
      displayMouseInfo(0, 0, e.button, e.ctrlKey);
    }

    private void axViewerCtrlActiveX1_OnMouseLeave(object sender, AxVIEWERCTRLAXLib._IViewerCtrlActiveXEvents_OnMouseLeaveEvent e)
    {
      radioMouseLeave.Checked = true;
      displayMouseInfo(0, 0, e.button, e.ctrlKey);
    }

    private void axViewerCtrlActiveX1_OnMouseMove(object sender, AxVIEWERCTRLAXLib._IViewerCtrlActiveXEvents_OnMouseMoveEvent e)
    {
      radioMouseMove.Checked = true;
      displayMouseInfo(e.x, e.y, e.button, e.ctrlKey);
    }

    private void axViewerCtrlActiveX1_OnMouseUp(object sender, AxVIEWERCTRLAXLib._IViewerCtrlActiveXEvents_OnMouseUpEvent e)
    {
      radioMouseUp.Checked = true;
      displayMouseInfo(e.x, e.y, e.button, e.ctrlKey);
    }

    private void axViewerCtrlActiveX1_OnStatusChange(object sender, AxVIEWERCTRLAXLib._IViewerCtrlActiveXEvents_OnStatusChangeEvent e)
    {
      if (e.statusCode == SC_GIO_ON)
      {
        alarmCount++;
        textGio.Text = alarmCount.ToString();
      }
      if (e.statusCode == SC_MOTION_ON)
      {
        motionCount++;
        textMotion.Text = motionCount.ToString();
      }
    }

    private void Form1_FormClosing(object sender, FormClosingEventArgs e)
    {
      this.axViewerCtrlActiveX1.Stop();
    }


    private void displayMouseInfo(int x, int y, int button, int key)
    {
      textMouseX.Text = x.ToString();
      textMouseY.Text = y.ToString();
      //show key
      bool isRight = false;
      if ((key & KB_BIT_CTRL) != 0)
      {
        isRight = (key & KB_BIT_CTRL_RIGHT) != 0;
        checkRightCtrl.Checked = isRight;
        checkLeftCtrl.Checked = !isRight;
      }
      else
      {
        checkRightCtrl.Checked = false;
        checkLeftCtrl.Checked = false;
      }
      if ((key & KB_BIT_SHIFT) != 0)
      {
        isRight = (key & KB_BIT_SHIFT_RIGHT) != 0;
        checkRightShift.Checked = isRight;
        checkLeftShift.Checked = !isRight;
      }
      else
      {
        checkRightShift.Checked = false;
        checkLeftShift.Checked = false;
      }

      if ((key & KB_BIT_ALT) != 0)
      {
        isRight = (key & KB_BIT_ALT_RIGHT) != 0;
        checkRightAlt.Checked = isRight;
        checkLeftAlt.Checked = !isRight;
      }
      else
      {
        checkRightAlt.Checked = false;
        checkLeftAlt.Checked = false;
      }
      //show mouse button
      checkMouseRight.Checked = (button & MB_BIT_RIGHT) != 0;
      checkMouseLeft.Checked = (button & MB_BIT_LEFT) != 0;
      checkMouseCenter.Checked = (button & MB_BIT_CENTER) != 0;



    }

    private void btnStart_Click(object sender, EventArgs e)
    {
      axViewerCtrlActiveX1.LiveURL = textUrl.Text;
      try
      {
        axViewerCtrlActiveX1.CHID = Int32.Parse(textCH.Text);
      }
      catch { };
      int mode = 0x10000000;
      switch (comboUIMode.SelectedIndex)
      {
        case 1:
          mode |= 3;
          break;

        case 2:
          mode |= 5;
          break;
      }
      axViewerCtrlActiveX1.UIMode = mode;
      axViewerCtrlActiveX1.MediaUsername = textUser.Text;
      axViewerCtrlActiveX1.MediaPassword = textPass.Text;
      try
      {
        axViewerCtrlActiveX1.NetworkTimeout = Int32.Parse(textTimeout.Text);
      }
      catch { };

      if (chkAudio.Checked)
      {
        axViewerCtrlActiveX1.IsPlaySound = 1;
        axViewerCtrlActiveX1.IsPlayAudioForStart = 1;
      }
      axViewerCtrlActiveX1.OnlyIFrame = (chkIFrame.Checked) ? 1 : 0;

      if (cmbDecoder.SelectedIndex == 1)
      {
        axViewerCtrlActiveX1.Decoder = "{04FE9017-F873-410E-871E-AB91661A4EF7}";
      }

      axViewerCtrlActiveX1.Start(3);
      axViewerCtrlActiveX1.StartReceiver();
      mIsViewing = (axViewerCtrlActiveX1.ViewStart()== 1);


    }

    private void btnStop_Click(object sender, EventArgs e)
    {
      axViewerCtrlActiveX1.ViewStop();
      axViewerCtrlActiveX1.StopReceiver();
      axViewerCtrlActiveX1.Stop();
    }

    private bool mIsViewing = false;

    private void btnRecord_Click(object sender, EventArgs e)
    {
      String filename = @"c:\temp\VDCTest.avi";
      if (System.IO.File.Exists(filename))
        System.IO.File.Delete(filename);

      if (!mIsViewing)
      {
        axViewerCtrlActiveX1.LiveURL = textUrl.Text;
        axViewerCtrlActiveX1.MediaUsername = textUser.Text;
        axViewerCtrlActiveX1.MediaPassword = textPass.Text;
        if (chkAudio.Checked)
        {
          axViewerCtrlActiveX1.IsPlaySound = 1;
        }
        axViewerCtrlActiveX1.Start(3);
        axViewerCtrlActiveX1.StartReceiver();
      }
      axViewerCtrlActiveX1.RecordAviStart(filename);

    }

    private void btnRecordStop_Click(object sender, EventArgs e)
    {
      axViewerCtrlActiveX1.RecordAviStop();
      if (!mIsViewing)
      {
        axViewerCtrlActiveX1.StopReceiver();
        axViewerCtrlActiveX1.Stop();
      }
    }

    private void btnShot_Click(object sender, EventArgs e)
    {
      String filename = @"c:\temp\VDCTest.jpg";
      axViewerCtrlActiveX1.SaveCurrentImage(filename);
    }

    private void button2_Click(object sender, EventArgs e)
    {
      axViewerCtrlActiveX1.LiveURL = textUrl.Text;
      axViewerCtrlActiveX1.MediaUsername = textUser.Text;
      axViewerCtrlActiveX1.MediaPassword = textPass.Text;
      String res = axViewerCtrlActiveX1.DeviceAPIEasySet(textApiName.Text, textApiValue.Text);
      String msg;
      switch (res)
      {
        case "OK":
          msg = "The operation is successful.";
          break;
        case "NG":
          msg = "An error occurred when executing the command.";
          break;
        case "NS":
          msg = "No such service exists.";
          break;
        case "UW":
          msg = "The command is unknown.";
          break;
        case "UA":
          msg = "Under authority (inadequate authority) to execute this command.";
          break;
        default:
          msg = "Unknow result code.";
          break;
      }
      MessageBox.Show(msg);
    }

    private void button3_Click(object sender, EventArgs e)
    {
      axViewerCtrlActiveX1.LiveURL = textUrl.Text;
      axViewerCtrlActiveX1.MediaPassword = textPass.Text;
      axViewerCtrlActiveX1.MediaUsername = textUser.Text;

      String val = axViewerCtrlActiveX1.DeviceAPIEasyGet(textApiName.Text);
      if (val == null || val.Equals(""))
      {
        int ec = axViewerCtrlActiveX1.GetLastErrorCode();
        String msg;
        switch (ec)
        {
          case ER_API_MSG_OK:
            msg = "The operation is successful.";
            break;
          case ER_API_MSG_NG:
            msg = "An error occurred when executing the command.";
            break;
          case ER_API_MSG_NS:
            msg = "No such service exists.";
            break;
          case ER_API_MSG_UW:
            msg = "The command is unknown.";
            break;
          case ER_API_MSG_UA:
            msg = "Under authority (inadequate authority) to execute this command.";
            break;
          default:
            msg = "Unknow result code.";
            break;
        }
        MessageBox.Show(msg);
      }
      else
      {
        textApiValue.Text = val;
      }
    }

    private void btnNew_Click(object sender, EventArgs e)
    {
      VCAForm f = new VCAForm();
      try
      {
        f.Run(textUrl.Text, textUser.Text, textPass.Text, comboUIMode.SelectedIndex, Int32.Parse(textCH.Text), Int32.Parse(textNewWidth.Text), Int32.Parse(textNewHeight.Text), Int32.Parse(textTimeout.Text));
      }
      catch { };
    }

    private void button1_Click(object sender, EventArgs e)
    {
      MessageBox.Show(axViewerCtrlActiveX1.Version());
    }

  }
}